Index: palm/trunk/SOURCE/urban_surface_mod.f90
===================================================================
--- palm/trunk/SOURCE/urban_surface_mod.f90	(revision 2693)
+++ palm/trunk/SOURCE/urban_surface_mod.f90	(revision 2696)
@@ -4844,16 +6541,23 @@
               ENDIF
 #endif
-              surf_usm_h%albedo_surf(m)    = -1.0_wp
+              surf_usm_h%albedo(:,m)    = -1.0_wp
               surf_usm_h%thickness_wall(m) = -1.0_wp
+              surf_usm_h%thickness_green(m) = -1.0_wp
+              surf_usm_h%thickness_window(m) = -1.0_wp
            ELSE
               IF ( usm_par(2,jw,iw)==0 )  THEN
                  surf_usm_h%isroof_surf(m)    = .FALSE.
                  surf_usm_h%thickness_wall(m) = -1.0_wp
+                 surf_usm_h%thickness_window(m) = -1.0_wp
+                 surf_usm_h%thickness_green(m)  = -1.0_wp
               ELSE
                  surf_usm_h%isroof_surf(m)    = .TRUE.
                  surf_usm_h%thickness_wall(m) = usm_val(2,jw,iw)
+                 surf_usm_h%thickness_window(m) = usm_val(2,jw,iw)
+                 surf_usm_h%thickness_green(m)  = usm_val(2,jw,iw)
               ENDIF
               surf_usm_h%surface_types(m) = usm_par(5,jw,iw)
-              surf_usm_h%albedo_surf(m)   = usm_val(1,jw,iw)
+              surf_usm_h%albedo(:,m)   = usm_val(1,jw,iw)
+              surf_usm_h%transmissivity(m)    = 0.0_wp
            ENDIF
 !
@@ -4875,19 +6579,27 @@
 !
 !--        Albedo
-           IF ( surf_usm_h%albedo_surf(m) < 0.0_wp )  THEN
-              surf_usm_h%albedo_surf(m) = surface_params(ialbedo,ip)
+           IF ( surf_usm_h%albedo(0,m) < 0.0_wp )  THEN
+              surf_usm_h%albedo(:,m) = surface_params(ialbedo,ip)
            ENDIF
+!--        Transmissivity
+           IF ( surf_usm_h%transmissivity(m) < 0.0_wp )  THEN
+              surf_usm_h%transmissivity(m) = 0.0_wp
+           ENDIF
 !
 !--        emissivity of the wall
-           surf_usm_h%emiss_surf(m) = surface_params(iemiss,ip)
+           surf_usm_h%emissivity(:,m) = surface_params(iemiss,ip)
 !            
 !--        heat conductivity Î»S between air and wall ( W mâ2 Kâ1 )
            surf_usm_h%lambda_surf(m) = surface_params(ilambdas,ip)
+           surf_usm_h%lambda_surf_window(m) = surface_params(ilambdas,ip)
+           surf_usm_h%lambda_surf_green(m)  = surface_params(ilambdas,ip)
 !            
 !--        roughness relative to concrete
-           surf_usm_h%roughness_wall(m) = surface_params(irough,ip)
+           surf_usm_h%z0(m) = surface_params(irough,ip)
 !            
 !--        Surface skin layer heat capacity (J mâ2 Kâ1 )
            surf_usm_h%c_surface(m) = surface_params(icsurf,ip)
+           surf_usm_h%c_surface_window(m) = surface_params(icsurf,ip)
+           surf_usm_h%c_surface_green(m)  = surface_params(icsurf,ip)
 !            
 !--        wall material parameters:
@@ -4897,10 +6609,20 @@
                 surf_usm_h%thickness_wall(m) = surface_params(ithick,ip)
            ENDIF
+           IF ( surf_usm_h%thickness_window(m) <= 0.001_wp )  THEN
+                surf_usm_h%thickness_window(m) = surface_params(ithick,ip)
+           ENDIF
+           IF ( surf_usm_h%thickness_green(m) <= 0.001_wp )  THEN
+                surf_usm_h%thickness_green(m) = surface_params(ithick,ip)
+           ENDIF
 !            
 !--        volumetric heat capacity rho*C of the wall ( J mâ3 Kâ1 )
            surf_usm_h%rho_c_wall(:,m) = surface_params(irhoC,ip)
+           surf_usm_h%rho_c_window(:,m) = surface_params(irhoC,ip)
+           surf_usm_h%rho_c_green(:,m)  = surface_params(irhoC,ip)
 !            
 !--        thermal conductivity Î»H of the wall (W mâ1 Kâ1 )
            surf_usm_h%lambda_h(:,m) = surface_params(ilambdah,ip)
+           surf_usm_h%lambda_h_window(:,m) = surface_params(ilambdah,ip)
+           surf_usm_h%lambda_h_green(:,m)  = surface_params(ilambdah,ip)
 
         ENDDO
@@ -4940,10 +6662,16 @@
                  IF ( usm_par(ii+1,jw,iw) == 0 )  THEN
                      surf_usm_v(l)%surface_types(m)  = pedestrant_category   !< default category for wall surface in pedestrant zone
-                     surf_usm_v(l)%albedo_surf(m)    = -1.0_wp
+                     surf_usm_v(l)%albedo(:,m)    = -1.0_wp
                      surf_usm_v(l)%thickness_wall(m) = -1.0_wp
+                     surf_usm_v(l)%thickness_window(m)   = -1.0_wp
+                     surf_usm_v(l)%thickness_green(m)    = -1.0_wp
+                     surf_usm_v(l)%transmissivity(m)  = -1.0_wp
                  ELSE
                      surf_usm_v(l)%surface_types(m)  = usm_par(ii+1,jw,iw)
-                     surf_usm_v(l)%albedo_surf(m)    = usm_val(ij,jw,iw)
+                     surf_usm_v(l)%albedo(:,m)    = usm_val(ij,jw,iw)
                      surf_usm_v(l)%thickness_wall(m) = usm_val(ij+1,jw,iw)
+                     surf_usm_v(l)%thickness_window(m)   = usm_val(ij+1,jw,iw)
+                     surf_usm_v(l)%thickness_green(m)    = usm_val(ij+1,jw,iw)
+                     surf_usm_v(l)%transmissivity(m)  = 0.0_wp
                  ENDIF
               ELSE IF ( kw <= usm_par(ii+2,jw,iw) )  THEN
@@ -4951,10 +6679,16 @@
                  IF ( usm_par(ii+3,jw,iw) == 0 )  THEN
                      surf_usm_v(l)%surface_types(m)  = wall_category         !< default category for wall surface
-                     surf_usm_v(l)%albedo_surf(m)    = -1.0_wp
+                     surf_usm_v(l)%albedo(:,m)    = -1.0_wp
                      surf_usm_v(l)%thickness_wall(m) = -1.0_wp
+                     surf_usm_v(l)%thickness_window(m)   = -1.0_wp
+                     surf_usm_v(l)%thickness_green(m)    = -1.0_wp
+                     surf_usm_v(l)%transmissivity(m)  = -1.0_wp
                  ELSE
                      surf_usm_v(l)%surface_types(m)  = usm_par(ii+3,jw,iw)
-                     surf_usm_v(l)%albedo_surf(m)    = usm_val(ij+2,jw,iw)
+                     surf_usm_v(l)%albedo(:,m)    = usm_val(ij+2,jw,iw)
                      surf_usm_v(l)%thickness_wall(m) = usm_val(ij+3,jw,iw)
+                     surf_usm_v(l)%thickness_window(m)   = usm_val(ij+3,jw,iw)
+                     surf_usm_v(l)%thickness_green(m)    = usm_val(ij+3,jw,iw)
+                     surf_usm_v(l)%transmissivity(m)  = 0.0_wp
                  ENDIF
               ELSE IF ( kw <= usm_par(ii+4,jw,iw) )  THEN
@@ -4962,10 +6696,16 @@
                  IF ( usm_par(ii+5,jw,iw) == 0 )  THEN
                      surf_usm_v(l)%surface_types(m)  = roof_category         !< default category for roof surface
-                     surf_usm_v(l)%albedo_surf(m)    = -1.0_wp
+                     surf_usm_v(l)%albedo(:,m)    = -1.0_wp
                      surf_usm_v(l)%thickness_wall(m) = -1.0_wp
+                     surf_usm_v(l)%thickness_window(m)   = -1.0_wp
+                     surf_usm_v(l)%thickness_green(m)    = -1.0_wp
+                     surf_usm_v(l)%transmissivity(m)  = -1.0_wp
                  ELSE
                      surf_usm_v(l)%surface_types(m)  = usm_par(ii+5,jw,iw)
-                     surf_usm_v(l)%albedo_surf(m)    = usm_val(ij+4,jw,iw)
+                     surf_usm_v(l)%albedo(:,m)    = usm_val(ij+4,jw,iw)
                      surf_usm_v(l)%thickness_wall(m) = usm_val(ij+5,jw,iw)
+                     surf_usm_v(l)%thickness_window(m)   = usm_val(ij+5,jw,iw)
+                     surf_usm_v(l)%thickness_green(m)    = usm_val(ij+5,jw,iw)
+                     surf_usm_v(l)%transmissivity(m)  = 0.0_wp
                  ENDIF
               ELSE
@@ -4992,19 +6732,27 @@
 !
 !--           Albedo
-              IF ( surf_usm_v(l)%albedo_surf(m) < 0.0_wp )  THEN
-                 surf_usm_v(l)%albedo_surf(m) = surface_params(ialbedo,ip)
+              IF ( surf_usm_v(l)%albedo(0,m) < 0.0_wp )  THEN
+                 surf_usm_v(l)%albedo(:,m) = surface_params(ialbedo,ip)
               ENDIF
+!--           Transmissivity of the windows
+              IF ( surf_usm_v(l)%transmissivity(m) < 0.0_wp )  THEN
+                 surf_usm_v(l)%transmissivity(m) = 0.0_wp
+              ENDIF
 !
 !--           emissivity of the wall
-              surf_usm_v(l)%emiss_surf(m) = surface_params(iemiss,ip)
+              surf_usm_v(l)%emissivity(:,m) = surface_params(iemiss,ip)
 !            
 !--           heat conductivity Î»S between air and wall ( W mâ2 Kâ1 )
               surf_usm_v(l)%lambda_surf(m) = surface_params(ilambdas,ip)
+              surf_usm_v(l)%lambda_surf_window(m) = surface_params(ilambdas,ip)
+              surf_usm_v(l)%lambda_surf_green(m) = surface_params(ilambdas,ip)
 !            
 !--           roughness relative to concrete
-              surf_usm_v(l)%roughness_wall(m) = surface_params(irough,ip)
+              surf_usm_v(l)%z0(m) = surface_params(irough,ip)
 !            
 !--           Surface skin layer heat capacity (J mâ2 Kâ1 )
               surf_usm_v(l)%c_surface(m) = surface_params(icsurf,ip)
+              surf_usm_v(l)%c_surface_window(m) = surface_params(icsurf,ip)
+              surf_usm_v(l)%c_surface_green(m) = surface_params(icsurf,ip)
 !            
 !--           wall material parameters:
@@ -5014,11 +6762,43 @@
                    surf_usm_v(l)%thickness_wall(m) = surface_params(ithick,ip)
               ENDIF
+              IF ( surf_usm_v(l)%thickness_window(m) <= 0.001_wp )  THEN
+                   surf_usm_v(l)%thickness_window(m) = surface_params(ithick,ip)
+              ENDIF
+              IF ( surf_usm_v(l)%thickness_green(m) <= 0.001_wp )  THEN
+                   surf_usm_v(l)%thickness_green(m) = surface_params(ithick,ip)
+              ENDIF
 !            
 !--           volumetric heat capacity rho*C of the wall ( J mâ3 Kâ1 )
               surf_usm_v(l)%rho_c_wall(:,m) = surface_params(irhoC,ip)
+              surf_usm_v(l)%rho_c_window(:,m) = surface_params(irhoC,ip)
+              surf_usm_v(l)%rho_c_green(:,m) = surface_params(irhoC,ip)
 !            
 !--           thermal conductivity Î»H of the wall (W mâ1 Kâ1 )
               surf_usm_v(l)%lambda_h(:,m) = surface_params(ilambdah,ip)
-
+              surf_usm_v(l)%lambda_h_window(:,m) = surface_params(ilambdah,ip)
+              surf_usm_v(l)%lambda_h_green(:,m) = surface_params(ilambdah,ip)
+
+           ENDDO
+        ENDDO 
+!
+!--     Initialize wall layer thicknesses. Please note, this will be removed
+!--     after migration to Palm input data standard.  
+        DO k = nzb_wall, nzt_wall
+           zwn(k) = zwn_default(k)
+           zwn_green(k) = zwn_default_green(k)
+           zwn_window(k) = zwn_default_window(k)
+        ENDDO
+!
+!--     apply for all particular surface grids. First for horizontal surfaces
+        DO  m = 1, surf_usm_h%ns
+           surf_usm_h%zw(:,m) = zwn(:) * surf_usm_h%thickness_wall(m)
+           surf_usm_h%zw_green(:,m) = zwn_green(:) * surf_usm_h%thickness_green(m)
+           surf_usm_h%zw_window(:,m) = zwn_window(:) * surf_usm_h%thickness_window(m)
+        ENDDO
+        DO  l = 0, 3
+           DO  m = 1, surf_usm_v(l)%ns
+              surf_usm_v(l)%zw(:,m) = zwn(:) * surf_usm_v(l)%thickness_wall(m)
+              surf_usm_v(l)%zw_green(:,m) = zwn_green(:) * surf_usm_v(l)%thickness_green(m)
+              surf_usm_v(l)%zw_window(:,m) = zwn_window(:) * surf_usm_v(l)%thickness_window(m)
            ENDDO
         ENDDO
@@ -5043,15 +6823,28 @@
         INTEGER(iwp)                          :: i, j, k, l, d, m   !< running indices
         
-        REAL(wp)                              :: pt1                !< temperature at first grid box adjacent to surface
         REAL(wp)                              :: u1,v1,w1           !< near wall u,v,w
         REAL(wp)                              :: stend              !< surface tendency
+        REAL(wp)                              :: stend_window       !< surface tendency
+        REAL(wp)                              :: stend_green        !< surface tendency
         REAL(wp)                              :: coef_1             !< first coeficient for prognostic equation
+        REAL(wp)                              :: coef_window_1      !< first coeficient for prognostic window equation
+        REAL(wp)                              :: coef_green_1       !< first coeficient for prognostic green wall equation
         REAL(wp)                              :: coef_2             !< second  coeficient for prognostic equation
+        REAL(wp)                              :: coef_window_2      !< second  coeficient for prognostic window equation
+        REAL(wp)                              :: coef_green_2       !< second  coeficient for prognostic green wall equation
         REAL(wp)                              :: rho_cp             !< rho_wall_surface * cp
         REAL(wp)                              :: r_a                !< aerodynamic resistance for horizontal and vertical surfaces
+        REAL(wp)                              :: r_a_window         !< aerodynamic resistance for horizontal and vertical window surfaces
+        REAL(wp)                              :: r_a_green          !< aerodynamic resistance for horizontal and vertical green surfaces
         REAL(wp)                              :: f_shf              !< factor for shf_eb
+        REAL(wp)                              :: f_shf_window       !< factor for shf_eb window
+        REAL(wp)                              :: f_shf_green        !< factor for shf_eb green wall
         REAL(wp)                              :: lambda_surface     !< current value of lambda_surface (heat conductivity between air and wall)
+        REAL(wp)                              :: lambda_surface_window !< current value of lambda_surface (heat conductivity between air and window)
+        REAL(wp)                              :: lambda_surface_green  !< current value of lambda_surface (heat conductivity between air and greeb wall)
         REAL(wp)                              :: Ueff               !< effective wind speed for calculation of heat transfer coefficients
         REAL(wp)                              :: httc               !< heat transfer coefficient
+        REAL(wp)                              :: httc_window        !< heat transfer coefficient window
+        REAL(wp)                              :: httc_green         !< heat transfer coefficient green wall
         REAL(wp), DIMENSION(nzub:nzut)        :: exn                !< value of the Exner function in layers
         
@@ -5068,5 +6861,4 @@
 !        
 !--     First, treat horizontal surface elements
-
         DO  m = 1, surf_usm_h%ns
 !
@@ -5081,12 +6873,15 @@
            IF ( surf_usm_h%ol(m) >= 0.0_wp )  THEN
               lambda_surface = surf_usm_h%lambda_surf(m)
+              lambda_surface_window = surf_usm_h%lambda_surf_window(m)
+              lambda_surface_green = surf_usm_h%lambda_surf_green(m)
            ELSE
               lambda_surface = surf_usm_h%lambda_surf(m)
+              lambda_surface_window = surf_usm_h%lambda_surf_window(m)
+              lambda_surface_green = surf_usm_h%lambda_surf_green(m)
            ENDIF
 #if ! defined( __nopointer )
-           pt1  = pt(k,j,i)
 !
 !--        calculate rho * cp coefficient at surface layer
-           rho_cp  = cp * hyp(k) / ( r_d * pt1 * exn(k) )
+           rho_cp  = cp * hyp(k) / ( r_d * surf_usm_h%pt1(m) * exn(k) )
 #endif
 !
@@ -5096,9 +6891,16 @@
 !--        data from the last time step is used here.
                
-           r_a = ( pt1 - t_surf_h(m) / exn(k) ) /                              &
-                 ( surf_usm_h%ts(m) * surf_usm_h%us(m) + 1.0E-10_wp )
+           r_a = ( surf_usm_h%pt1(m) - t_surf_h(m) / exn(k) ) /                              &
+                 ( surf_usm_h%ts(m) * surf_usm_h%us(m) + 1.0E-20_wp )
+           r_a_window = ( surf_usm_h%pt1(m) - t_surf_window_h(m) / exn(k) ) /                &
+                 ( surf_usm_h%ts(m) * surf_usm_h%us(m) + 1.0E-20_wp )
+           r_a_green = ( surf_usm_h%pt1(m) - t_surf_green_h(m) / exn(k) ) /                  &
+                 ( surf_usm_h%ts(m) * surf_usm_h%us(m) + 1.0E-20_wp )
                 
 !--        make sure that the resistance does not drop to zero
-           IF ( ABS(r_a) < 1.0E-10_wp )  r_a = 1.0E-10_wp
+           IF ( r_a        < 1.0_wp )  r_a        = 1.0_wp
+           IF ( r_a_window < 1.0_wp )  r_a_window = 1.0_wp
+           IF ( r_a_green  < 1.0_wp )  r_a_green  = 1.0_wp
+
                 
 !--        the parameterization is developed originally for larger scales
@@ -5106,27 +6908,50 @@
 !--        our first experiences show that the parameterization underestimates
 !--        r_a in meter resolution.
-!--        temporary solution - multiplication by magic constant :-(.
-           r_a = r_a * ra_horiz_coef
+!--        A temporary solution would be multiplication by magic constant :-(.
+!--        For the moment this is comment out.
+           r_a        = r_a        !* ra_horiz_coef
+           r_a_window = r_a_window !* ra_horiz_coef
+           r_a_green  = r_a_green  !* ra_horiz_coef
                 
 !--        factor for shf_eb
            f_shf  = rho_cp / r_a
+           f_shf_window  = rho_cp / r_a_window
+           f_shf_green  = rho_cp / r_a_green
         
 !--        add LW up so that it can be removed in prognostic equation
-           surf_usm_h%rad_net_l(m) = surf_usm_h%rad_in_sw(m)  -                &
-                                     surf_usm_h%rad_out_sw(m) +                &
-                                     surf_usm_h%rad_in_lw(m)  -                &
-                                     surf_usm_h%rad_out_lw(m)
+           surf_usm_h%rad_net_l(m) = surf_usm_h%rad_sw_in(m)  -                &
+                                     surf_usm_h%rad_sw_out(m) +                &
+                                     surf_usm_h%rad_lw_in(m)  -                &
+                                     surf_usm_h%rad_lw_out(m)
 
 !--        numerator of the prognostic equation
+!--     Todo: Adjust to tile approach. So far, emissivity for wall (element 0)
+!--           is used
            coef_1 = surf_usm_h%rad_net_l(m) +                                  & 
-                   ( 3.0_wp + 1.0_wp ) * surf_usm_h%emiss_surf(m) * sigma_sb * &
+                 ( 3.0_wp + 1.0_wp ) * surf_usm_h%emissivity(0,m) * sigma_sb * &
                                        t_surf_h(m) ** 4 +                      &  
-                                       f_shf * pt1 +                           &
+                                       f_shf * surf_usm_h%pt1(m) +                           &
                                        lambda_surface * t_wall_h(nzb_wall,m)
+           coef_window_1 = surf_usm_h%rad_net_l(m) +                                  & 
+                   ( 3.0_wp + 1.0_wp ) * surf_usm_h%emissivity(2,m) * sigma_sb * &
+                                       t_surf_window_h(m) ** 4 +                      &  
+                                       f_shf_window * surf_usm_h%pt1(m) +                           &
+                                       lambda_surface_window * t_window_h(nzb_wall,m)
+           coef_green_1 = surf_usm_h%rad_net_l(m) +                                  & 
+                   ( 3.0_wp + 1.0_wp ) * surf_usm_h%emissivity(1,m) * sigma_sb * &
+                                       t_surf_green_h(m) ** 4 +                      &  
+                                       f_shf_green * surf_usm_h%pt1(m) +                           &
+                                       lambda_surface_green * t_wall_h(nzb_wall,m)
 
 !--        denominator of the prognostic equation
-           coef_2 = 4.0_wp * surf_usm_h%emiss_surf(m) * sigma_sb *            &
+           coef_2 = 4.0_wp * surf_usm_h%emissivity(0,m) * sigma_sb *          &
                              t_surf_h(m) ** 3                                 &
                            + lambda_surface + f_shf / exn(k)
+           coef_window_2 = 4.0_wp * surf_usm_h%emissivity(2,m) * sigma_sb *  &
+                             t_surf_window_h(m) ** 3                              &
+                           + lambda_surface_window + f_shf_window / exn(k)
+           coef_green_2 = 4.0_wp * surf_usm_h%emissivity(1,m) * sigma_sb *    &
+                             t_surf_green_h(m) ** 3                               &
+                           + lambda_surface_green + f_shf_green / exn(k)
 
 !--        implicit solution when the surface layer has no heat capacity,
@@ -5135,12 +6960,32 @@
                              surf_usm_h%c_surface(m) * t_surf_h(m) ) /        & 
                            ( surf_usm_h%c_surface(m) + coef_2 * dt_3d * tsc(2) ) 
+           t_surf_window_h_p(m) = ( coef_window_1 * dt_3d * tsc(2) +                        &
+                             surf_usm_h%c_surface_window(m) * t_surf_window_h(m) ) /        & 
+                           ( surf_usm_h%c_surface_window(m) + coef_window_2 * dt_3d * tsc(2) ) 
+           t_surf_green_h_p(m) = ( coef_green_1 * dt_3d * tsc(2) +                        &
+                             surf_usm_h%c_surface_green(m) * t_surf_green_h(m) ) /        & 
+                           ( surf_usm_h%c_surface_green(m) + coef_green_2 * dt_3d * tsc(2) ) 
 
 !--        add RK3 term
            t_surf_h_p(m) = t_surf_h_p(m) + dt_3d * tsc(3) *                   &
                            surf_usm_h%tt_surface_m(m)
-            
+           t_surf_window_h_p(m) = t_surf_window_h_p(m) + dt_3d * tsc(3) *     &
+                           surf_usm_h%tt_surface_window_m(m)
+           t_surf_green_h_p(m) = t_surf_green_h_p(m) + dt_3d * tsc(3) *       &
+                           surf_usm_h%tt_surface_green_m(m)
+!
+!--        Store surface temperature        
+           surf_usm_h%pt_surface(m) = ( surf_usm_h%frac(0,m) * t_surf_h_p(m)   &
+                               + surf_usm_h%frac(2,m) * t_surf_window_h_p(m)   &
+                               + surf_usm_h%frac(1,m) * t_surf_green_h_p(m) )  &
+                               / exn(k)
+                       
 !--        calculate true tendency
            stend = ( t_surf_h_p(m) - t_surf_h(m) - dt_3d * tsc(3) *           &
                      surf_usm_h%tt_surface_m(m)) / ( dt_3d  * tsc(2) )
+           stend_window = ( t_surf_window_h_p(m) - t_surf_window_h(m) - dt_3d * tsc(3) *        &
+                     surf_usm_h%tt_surface_window_m(m)) / ( dt_3d  * tsc(2) )
+           stend_green = ( t_surf_green_h_p(m) - t_surf_green_h(m) - dt_3d * tsc(3) *           &
+                     surf_usm_h%tt_surface_green_m(m)) / ( dt_3d  * tsc(2) )
 
 !--        calculate t_surf tendencies for the next Runge-Kutta step
@@ -5148,8 +6993,14 @@
               IF ( intermediate_timestep_count == 1 )  THEN
                  surf_usm_h%tt_surface_m(m) = stend
+                 surf_usm_h%tt_surface_window_m(m) = stend_window
+                 surf_usm_h%tt_surface_green_m(m) = stend_green
               ELSEIF ( intermediate_timestep_count <                          &
                         intermediate_timestep_count_max )  THEN
                  surf_usm_h%tt_surface_m(m) = -9.5625_wp * stend +            &
                                      5.3125_wp * surf_usm_h%tt_surface_m(m)
+                 surf_usm_h%tt_surface_window_m(m) = -9.5625_wp * stend_window +   &
+                                     5.3125_wp * surf_usm_h%tt_surface_window_m(m)
+                 surf_usm_h%tt_surface_green_m(m) = -9.5625_wp * stend_green +     &
+                                     5.3125_wp * surf_usm_h%tt_surface_green_m(m)
               ENDIF
            ENDIF
@@ -5157,5 +7008,7 @@
 !--        in case of fast changes in the skin temperature, it is required to
 !--        update the radiative fluxes in order to keep the solution stable
-           IF ( ABS( t_surf_h_p(m) - t_surf_h(m) ) > 1.0_wp )  THEN
+           IF ( ( ABS( t_surf_h_p(m) - t_surf_h(m) ) > 1.0_wp ) .OR. &
+                ( ABS( t_surf_green_h_p(m) - t_surf_green_h(m) ) > 1.0_wp ) .OR. &
+                ( ABS( t_surf_window_h_p(m) - t_surf_window_h(m) ) > 1.0_wp ) ) THEN
               force_radiation_call_l = .TRUE.
            ENDIF
@@ -5166,18 +7019,42 @@
 !--        using surface and wall heat fluxes
 #if ! defined( __nopointer )
-           pt(k-1,j,i) = t_surf_h_p(m) / exn(k)  ! not for vertical surfaces
+!            pt(k-1,j,i) = ( surf_usm_h%frac(0,m) * t_surf_h_p(m)       &
+!                          + surf_usm_h%frac(2,m) * t_surf_window_h_p(m)  &
+!                          + surf_usm_h%frac(1,m) * t_surf_green_h_p(m) ) &
+!                          / exn(k)  ! not for vertical surfaces
 #endif
 
 !--        calculate fluxes
 !--        rad_net_l is never used!           
-           surf_usm_h%rad_net_l(m) = surf_usm_h%rad_net_l(m) +                &
-                                     3.0_wp * sigma_sb *                      &
-                                     t_surf_h(m)**4 - 4.0_wp * sigma_sb *     &
-                                     t_surf_h(m)**3 * t_surf_h_p(m)
+           surf_usm_h%rad_net_l(m) = surf_usm_h%frac(0,m) *                         &
+                                     ( surf_usm_h%rad_net_l(m) +                    &
+                                     3.0_wp * sigma_sb *                            &
+                                     t_surf_h(m)**4 - 4.0_wp * sigma_sb *           &
+                                     t_surf_h(m)**3 * t_surf_h_p(m) )               &
+                                   + surf_usm_h%frac(2,m) *                         &
+                                     ( surf_usm_h%rad_net_l(m) +                    &
+                                     3.0_wp * sigma_sb *                            &
+                                     t_surf_window_h(m)**4 - 4.0_wp * sigma_sb *    &
+                                     t_surf_window_h(m)**3 * t_surf_window_h_p(m) ) &
+                                   + surf_usm_h%frac(1,m) *                         &
+                                     ( surf_usm_h%rad_net_l(m) +                    &
+                                     3.0_wp * sigma_sb *                            &
+                                     t_surf_green_h(m)**4 - 4.0_wp * sigma_sb *     &
+                                     t_surf_green_h(m)**3 * t_surf_green_h_p(m) )
            surf_usm_h%wghf_eb(m)   = lambda_surface *                         &
                                       ( t_surf_h_p(m) - t_wall_h(nzb_wall,m) )
+           surf_usm_h%wghf_eb_green(m)  = lambda_surface_green *                        &
+                                          ( t_surf_green_h_p(m) - t_green_h(nzb_wall,m) )
+           surf_usm_h%wghf_eb_window(m) = lambda_surface_window *                       &
+                                           ( t_surf_window_h_p(m) - t_window_h(nzb_wall,m) )
+
 !
 !--        ground/wall/roof surface heat flux
-           surf_usm_h%wshf_eb(m)   = - f_shf  * ( pt1 - t_surf_h_p(m) )
+           surf_usm_h%wshf_eb(m)   = - f_shf  * ( surf_usm_h%pt1(m) - t_surf_h_p(m) / exn(k) ) *               &
+                                       surf_usm_h%frac(0,m)                         &
+                                     - f_shf_window  * ( surf_usm_h%pt1(m) - t_surf_window_h_p(m) / exn(k) ) * &
+                                       surf_usm_h%frac(2,m)                          &
+                                     - f_shf_green  * ( surf_usm_h%pt1(m) - t_surf_green_h_p(m) / exn(k) ) *   &
+                                       surf_usm_h%frac(1,m)
 !           
 !--        store kinematic surface heat fluxes for utilization in other processes
@@ -5195,4 +7072,5 @@
              j = surf_usm_v(l)%j(m)
              k = surf_usm_v(l)%k(m)
+
 !
 !--          TODO - how to calculate lambda_surface for horizontal (??? do you mean verical ???) surfaces
@@ -5201,9 +7079,11 @@
 !--          stratification is not considered in this case.
              lambda_surface = surf_usm_v(l)%lambda_surf(m)
+             lambda_surface_window = surf_usm_v(l)%lambda_surf_window(m)
+             lambda_surface_green = surf_usm_v(l)%lambda_surf_green(m)
+
 #if ! defined( __nopointer )          
-             pt1  = pt(k,j,i)
 !
 !--          calculate rho * cp coefficient at surface layer
-             rho_cp  = cp * hyp(k) / ( r_d * pt1 * exn(k) )
+             rho_cp  = cp * hyp(k) / ( r_d * surf_usm_v(l)%pt1(m) * exn(k) )
 #endif
 
